module Main where

import System
import System.IO
import System.Exit

main :: IO ()
main = do
          args <- getArgs
          case args of
            [x,y,z] -> print (tarai (read x :: Int)
                                    (read y :: Int)
                                    (read z :: Int))
            _ -> do
                    hPutStrLn stderr "wrong # of arguments"
                    exitFailure

tarai :: Int -> Int -> Int -> Int
tarai x y z
    | x <= y    = y
    | otherwise = tarai (tarai (x-1) y z)
                        (tarai (y-1) z x)
                        (tarai (z-1) x y)
