#include <stdio.h>
#include <stdlib.h>

void*
xmalloc(long size)
{
    void *p;
    
    p = malloc(size);
    if (!p) {
        fprintf(stderr, "malloc failed");
        exit(1);
    }
    return p;
}

void*
xcalloc(long size, long n)
{
    void *p;
    
    p = calloc(size, n);
    if (!p) {
        fprintf(stderr, "calloc failed");
        exit(1);
    }
    return p;
}
