#
# emulate lazy evaluation
#
# Author: sheepman
# modified by Minero Aoki
#

def tarai( x, y, z )
  if x.call <= y.call
  then y.call
  else tarai(lambda { tarai(lambda{x.call-1}, y, z) },
             lambda { tarai(lambda{y.call-1}, z, x) },
             lambda { tarai(lambda{z.call-1}, x, y) })
  end
end

puts tarai(lambda{ARGV[0].to_i}, lambda{ARGV[1].to_i}, lambda{ARGV[2].to_i})
