#
# apply lazy evaluation only for 3rd argument
#
# Author: Shin-ichiro HARA
# modified by Minero Aoki
#

def tarai( x, y )
  if x <= y
  then y
  else
    z = yield
    tarai(tarai(x-1, y){z}, tarai(y-1, z){x}){ tarai(z-1, x){y} }
  end
end

puts tarai(ARGV[0].to_i, ARGV[1].to_i){ARGV[2].to_i}
