#
# multi-dimension hash
#
# Author: K.Sasada
# modified by Minero Aoki
#

$memo = {}

def tarai2( x, y, z )
  getv(x,y,z) || putv(x,y,z)
end

def getv( x, y, z )
  ($memo[x] && $memo[x][y] && $memo[x][y][z])
end

def putv( x, y, z )
  r = if x <= y
    y
  else
    tarai2(
      tarai2(x-1,y,z),
      tarai2(y-1,z,x),
      tarai2(z-1,x,y))
  end
  x = $memo[x] ||= {x=>{}}
  #p x
  y = x[y] ||= {y=>{}}
  #p y
  y[z] = r
end

puts tarai2(ARGV[0].to_i, ARGV[1].to_i, ARGV[2].to_i)
