;; Original definition of TAK Function
(defun tarai (x y z)
  (cond ((> x y)
	 (tarai
	  (tarai (1- x) y z)
	  (tarai (1- y) z x)
	  (tarai (1- z) x y) ))
	(t y) ))

;; John Macarthy's variation of TARAI function
(defun tak (x y z)
  (cond ((not (< y x)) z)
	(t
	  (tak
	    (tak (1- x) y z)
	    (tak (1- y) z x)
	    (tak (1- z) x y)))))
